﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PaintNew
{
    public partial class uiPictureBox : UserControl
    {    
        //sajjad soltani
        //email : s.soltani1989@gmail.com
        //0355503633


        #region Fields...

        private Image _imageChecked;
        private Image _imageUnChecked;
        private System.Windows.Forms.BorderStyle _currentBordeStyle;
        private System.Drawing.Color _currentBackColor;
        private bool _activeMouseTracing;

        #endregion

        #region Properties...

        public bool VisibleCheckBox
        {
            get { return checkBox1.Visible; }
            set { checkBox1.Visible  = value; }
        }

        public Image ImageChecked
        {
            get { return _imageChecked; }
            set { _imageChecked = value; }
        }

        public Image ImageUnChecked
        {
            get { return _imageUnChecked; }
            set {
                _imageUnChecked = value;
                this.BackgroundImage = value;
            }
        }

        public bool CheckBoxValue
        {
            get { return checkBox1.Checked; }
            set {
                if (ChangeCheckBox != null)
                    ChangeCheckBox(this,new EventChangeBox{ CheckStatus = checkBox1.Checked});

                if (value == true)
                    this.BackgroundImage = ImageChecked;  
                else
                    this.BackgroundImage = ImageUnChecked; 
                checkBox1.Checked = value; }
        }

        public bool ActiveMouseTracing
        {
            get { return _activeMouseTracing; }
            set
            {
                if (value)
                    BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
                _activeMouseTracing = value;
            }
        }

        public System.Drawing.Color ColorTracing { get; set; }

        #endregion

        #region Event...

        public event ChangeCheckBoxDelegate ChangeCheckBox;

        protected override void OnMouseEnter(EventArgs e)
        {
            base.OnMouseEnter(e);
            if (ActiveMouseTracing)
            {
                _currentBackColor = this.BackColor;
                this.BackColor = ColorTracing;
                this.Refresh();
            }
        }

        protected override void OnMouseLeave(EventArgs e)
        {
            base.OnMouseLeave(e);

            if (ActiveMouseTracing)
            {
                this.BackColor = _currentBackColor;
            }
        }

        protected override void OnMouseUp(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseUp(e);

            if (ActiveMouseTracing && e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                this.BorderStyle = _currentBordeStyle;
            }
        }

        protected override void OnMouseDown(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseDown(e);
            if (ActiveMouseTracing && e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                _currentBordeStyle = this.BorderStyle;
                this.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            }
        }

        #endregion



        public uiPictureBox()
        {
            InitializeComponent();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            CheckBoxValue = ((CheckBox)sender).Checked;
        }


    }
}
